<template>
  <div
    data-component-group="auth-form"
    data-component="business-profile"
  >
    <Form
      title="Register"
      second-title="Business Profile"
    >
      <v-text-field
        v-model="name"
        label="Name"
        required
        :readonly="isDisabled"
        type="text"
        :autofocus="true"
        :error-messages="nameErrors"
        @blur="$v.name.$touch()"
      />

      <v-text-field
        v-model="shopUrl"
        label="Shop URL"
        :readonly="isDisabled"
        required
        type="text"
        :error-messages="shopUrlErrors"
        @blur="$v.shopUrl.$touch()"
      />

      <v-text-field
        v-model="invoiceEmail"
        label="Invoice Email"
        :readonly="isDisabled"
        required
        type="text"
        :error-messages="invoiceEmailErrors"
        @blur="$v.invoiceEmail.$touch()"
      />

      <v-text-field
        v-if="hasEmailDomain"
        v-model="emailDomain"
        label="Email domain"
        :readonly="isDisabled"
        required
        type="text"
        :error-messages="emailDomainErrors"
        @blur="$v.emailDomain.$touch()"
      />

      <v-text-field
        v-model="address"
        label="Address"
        :readonly="isDisabled"
        required
        type="text"
        :error-messages="addressErrors"
        @blur="$v.address.$touch()"
      />

      <v-text-field
        v-model="secondAddress"
        :readonly="isDisabled"
        label="Address line 2 (optional)"
        required
        type="text"
      />

      <v-flex xs12>
        <v-layout>
          <v-flex xs6>
            <v-text-field
              v-model="city"
              label="City"
              required
              :readonly="isDisabled"
              type="text"
              class="city-field fluid-field"
              :error-messages="cityErrors"
              @blur="$v.city.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <v-text-field
              v-model="state"
              label="State (optional)"
              required
              :readonly="isDisabled"
              type="text"
              class="fluid-field"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <v-flex xs12>
        <v-layout>
          <v-flex xs6>
            <v-text-field
              v-model="zipCode"
              label="Zip code"
              required
              :readonly="isDisabled"
              type="text"
              class="zip-code-field fluid-field"
              :error-messages="zipCodeErrors"
              @blur="$v.zipCode.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <v-autocomplete
              v-model="country"
              :items="countries"
              :filter="customFilter"
              :readonly="isDisabled"
              label="Country"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              prepend-inner-icon="public"
              class="country-dropdown fluid-field"
              :error-messages="countryErrors"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <VueRecaptcha
        v-if="hasRecaptcha"
        :sitekey="apiKey"
        size="invisible"
        @verify="onVerify"
      />

      <div class="form-actions">
        <v-flex xs12>
          <v-layout :justify-space-between="true">
            <v-btn
              v-if="hasOnCancel"
              flat
              class="trigger go-back"
              @click="onCancel"
            >
              <v-icon v-if="cancelIcon !== ''">
                {{ cancelIcon }}
              </v-icon>
              {{ cancelTriggerLabel }}
            </v-btn>
            <v-btn
              v-if="hasOnSubmit && !isDisabled"
              flat
              class="trigger register"
              :loading="isLoading"
              @click="submit"
            >
              <v-icon v-if="confirmIcon !== ''">
                {{ confirmIcon }}
              </v-icon>
              {{ confirmTriggerLabel }}
            </v-btn>
          </v-layout>
        </v-flex>
      </div>
    </Form>
  </div>
</template>

<script>
  import VueRecaptcha from 'vue-recaptcha';
  import { validationMixin } from 'vuelidate';
  import { required, url, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form';
  import router from '../../../router';
  import domain from '../../../validators/domain';
  import { isFunc, isObj } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      Form,
      VueRecaptcha
    },
    mixins: [validationMixin],
    validations() {
      return {
        name: {
          required
        },
        shopUrl: {
          required,
          url
        },
        invoiceEmail: {
          required,
          email
        },
        emailDomain: this.hasEmailDomain ? {
          required,
          domain
        } : {},
        address: {
          required
        },
        city: {
          required
        },
        zipCode: {
          required
        },
        country: {
          required
        }
      };
    },
    props: {
      businessProfile: {
        type: Object,
        default: undefined
      },
      cancelTriggerLabel: {
        type: String,
        default: 'Cancel'
      },
      confirmTriggerLabel: {
        type: String,
        default: 'Create account'
      },
      cancelIcon: {
        type: String,
        default: 'chevron_left'
      },
      confirmIcon: {
        type: String,
        default: 'business_center'
      },
      isLoading: {
        type: Boolean,
        default: false
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      hasEmailDomain: {
        type: Boolean,
        default: false
      },
      hasRecaptcha: {
        type: Boolean,
        default: false
      },
      onCancel: {
        type: Function,
        default: undefined
      },
      onSubmit: {
        type: Function,
        default: undefined
      }
    },
    data: () => ({
      name: '',
      shopUrl: '',
      invoiceEmail: '',
      emailDomain: '',
      address: '',
      secondAddress: '',
      city: '',
      state: '',
      zipCode: '',
      country: '',
      isSubmitted: false,
      countries: [],
      recaptcha: '',
      apiKey: process.env.VUE_APP_RECAPTCHA_KEY,
      colors
    }),
    computed: {
      hasOnCancel() {
        return isFunc(this.onCancel);
      },
      hasOnSubmit() {
        return isFunc(this.onSubmit);
      },
      hasItem() {
        return isObj(this.businessProfile);
      },
      nameErrors() {
        const errors = [];
        if (!this.$v.name.$dirty) {
          return errors;
        }
        if (!this.$v.name.required) {
          errors.push('Name is required');
        }
        return errors;
      },
      shopUrlErrors() {
        const errors = [];
        if (!this.$v.shopUrl.$dirty) {
          return errors;
        }
        if (!this.$v.shopUrl.required) {
          errors.push('Shop URL is required');
        }
        if (!this.$v.shopUrl.url) {
          errors.push('Must be a valid URL');
        }
        return errors;
      },
      invoiceEmailErrors() {
        const errors = [];
        if (!this.$v.invoiceEmail.$dirty) {
          return errors;
        }
        if (!this.$v.invoiceEmail.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_required'));
        }
        if (!this.$v.invoiceEmail.email) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_valid'));
        }
        return errors;
      },
      emailDomainErrors() {
        const errors = [];
        if (!this.$v.emailDomain.$dirty) {
          return errors;
        }
        if (!this.$v.emailDomain.required) {
          errors.push('Email domain is required');
        }
        if (!this.$v.emailDomain.domain) {
          errors.push('Must be a valid domain');
        }
        return errors;
      },
      addressErrors() {
        const errors = [];
        if (!this.$v.address.$dirty) {
          return errors;
        }
        if (!this.$v.address.required) {
          errors.push('Address is required');
        }
        return errors;
      },
      cityErrors() {
        const errors = [];
        if (!this.$v.city.$dirty) {
          return errors;
        }
        if (!this.$v.city.required) {
          errors.push('City is required');
        }
        return errors;
      },
      zipCodeErrors() {
        const errors = [];
        if (!this.$v.zipCode.$dirty) {
          return errors;
        }
        if (!this.$v.zipCode.required) {
          errors.push('Zip code is required');
        }
        return errors;
      },
      countryErrors() {
        const errors = [];
        if (!this.$v.country.$dirty) {
          return errors;
        }
        if (!this.$v.country.required) {
          errors.push('Country is required');
        }
        return errors;
      }
    },
    watch: {
      businessProfile(nextItem) {
        if (isObj(nextItem)) {
          this.extractItemData(nextItem);
        }
      }
    },
    created() {
      return this.$store.dispatch('config/getAllCountries')
        .then((countries) => {
          this.countries = countries;
          return countries;
        });
    },
    methods: {
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }
        this.createAccount();
      },
      clear() {
        this.$v.$reset();
        this.name = '';
        this.shopUrl = '';
        this.invoiceEmail = '';
        this.emailDomain = '';
        this.address = '';
        this.secondAddress = '';
        this.city = '';
        this.state = '';
        this.zipCode = '';
        this.country = '';
        this.isSubmitted = false;
      },
      createAccount() {
        const [targetCountry] = this.countries.filter(country => country.code === this.country);
        const businessProfile = {
          name: this.name,
          shopUrl: this.shopUrl,
          invoiceEmail: this.invoiceEmail,
          emailDomain: this.emailDomain,
          address: this.address,
          secondAddress: this.secondAddress,
          city: this.city,
          state: this.state,
          zipCode: this.zipCode,
          country: targetCountry.code
        };

        if (this.hasRecaptcha) {
          businessProfile.recaptcha = this.recaptcha;
        }

        this.onSubmit(businessProfile);
      },
      extractItemData(businessProfile) {
        const { name, shopUrl, invoiceEmail, emailDomain, address, secondAddress, city, state, zipCode, country } = businessProfile;
        this.name = name;
        this.shopUrl = shopUrl;
        this.invoiceEmail = invoiceEmail;
        this.emailDomain = emailDomain;
        this.address = address;
        this.secondAddress = secondAddress;
        this.city = city;
        this.state = state;
        this.zipCode = zipCode;
        this.country = country;
      },
      canSubmitRequest() {
        return this.name !== ''
          && this.shopUrl !== ''
          && this.invoiceEmail !== ''
          && (!this.hasEmailDomain || (this.hasEmailDomain && this.emailDomain !== ''))
          && this.address !== ''
          && this.city !== ''
          && this.zipCode !== ''
          && this.country !== ''
          && (!this.hasRecaptcha || (this.hasRecaptcha && this.recaptcha !== ''))
          && !this.isSubmitted;
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      onVerify(res) {
        this.recaptcha = res;
      }
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="auth-form"] {
    &[data-component="business-profile"] {
      .form-actions {
        .trigger.go-back {
          border-radius: 4px;
          color: $colors.shades.black;
          background-color: $colors.grey.lighten-2;
        }

        .trigger.register {
          border-radius: 4px;
          color: $colors.shades.white;
          background-color: $colors.primary;

          .v-icon {
            margin: 0 6px 0 0;
          }
        }
      }
    }
  }
</style>
